%global pypi_name pinakes
%global product_name automation-services-catalog
%global ui_name automation-catalog-ui
%global commitId_pinakes d5e5f03818b11e4e35d7d68388392a86e4ea1eca
%global commitId_catalog_ui 1f1785f87ee4e4f0f500f0636d96b9c983430945
%global debug_package %{nil}

Name:           %{product_name}
Version:        1.0.9
Release:        3%{?dist}
Summary:        Red Hat Ansible Automation Platform Services Catalog

License:        ASL 2.0
URL:            https://github.com/ansible/pinakes.git
Source0:        pinakes-d5e5f03818b11e4e35d7d68388392a86e4ea1eca.tar.gz
Source1:        automation-catalog-ui-1f1785f87ee4e4f0f500f0636d96b9c983430945.tar.gz
Source2:        automation-services-catalog.service
Source3:        automation-services-catalog-worker.service
Source4:        automation-services-catalog-scheduler.service
Source5:        image_overrides.tar.xz
Source6:        automation-services-catalog.socket
Source7:        automation-services-catalog.target
Patch1:         pinakes-webpack-Avoid-md4-hash-for-OpenSSL-3.patch
BuildArch:      x86_64

BuildRequires:  cairo-devel
BuildRequires:  gcc-c++
BuildRequires:  giflib-devel
BuildRequires:  libjpeg-devel
BuildRequires:  make
BuildRequires:  nodejs-devel
BuildRequires:  npm
BuildRequires:  pango-devel
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-pbr
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  systemd

BuildRequires: /usr/bin/pathfix.py

%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}}
Requires:  ansible-automation-platform-common
Requires:  nginx
Requires:  postgresql
Requires:  python%{python3_pkgversion}-cryptography
Requires:  python%{python3_pkgversion}-dateutil
Requires:  python%{python3_pkgversion}-distro
Requires:  python%{python3_pkgversion}-django
Requires:  python%{python3_pkgversion}-django-cors-headers
Requires:  python%{python3_pkgversion}-django-environ
Requires:  python%{python3_pkgversion}-django-filter
Requires:  python%{python3_pkgversion}-django-rq
Requires:  python%{python3_pkgversion}-django-taggit
Requires:  python%{python3_pkgversion}-djangorestframework
Requires:  python%{python3_pkgversion}-drf-extensions
Requires:  python%{python3_pkgversion}-drf-spectacular
Requires:  python%{python3_pkgversion}-gunicorn
Requires:  python%{python3_pkgversion}-insights-analytics-collector
# python-jose needed for social-auth-core[openidconnect]
Requires:  python%{python3_pkgversion}-jose
Requires:  python%{python3_pkgversion}-pillow
Requires:  python%{python3_pkgversion}-psycopg2
Requires:  python%{python3_pkgversion}-pydantic
Requires:  python%{python3_pkgversion}-pytz
Requires:  python%{python3_pkgversion}-requests
Requires:  python%{python3_pkgversion}-rq >= 1.10.1
Requires:  python%{python3_pkgversion}-rq-scheduler
Requires:  python%{python3_pkgversion}-social-auth-app-django
Requires:  python%{python3_pkgversion}-social-auth-core
Requires:  python3-libsemanage
Requires:  redis
Requires:  rsyslog
Requires:  sos
Requires:  systemd

%description
Ansible Automation Services Catalog allows customers to expose their Ansible
Job Templates and Workflows to business users with an added layer of governance.
The Job Templates and Workflows are wrapped as Products into Portfolios which
can be shared with different business users. An approval workflow can be
attached to Products or Portfolios which adds governance and, in the future,
will be able to notify the appropriate Administrators via email. Upon approval,
the Job Template or workflow will be launched on the Ansible Controller.

%prep
%autosetup -S git -T -b 1 -n automation-catalog-ui-%{commitId_catalog_ui}
%autosetup -N -T -a 5 -c -n automation-catalog-ui-productization
%autosetup -N -n %{pypi_name}-%{commitId_pinakes}

# Fix all Python shebangs recursively in .
pathfix.py -pni "%{__python3} %{py3_shbang_opts}" .

%build
export PBR_VERSION=%{version}
%{py3_build}

# init npm
npm_registry_override="https://repository.engineering.redhat.com/nexus/repository/registry.npmjs.org/"
npm config set registry ${npm_registry_override}
npm config set strict-ssl false
npm config set nodedir %{_exec_prefix}

# build catalog-ui
cd %{_builddir}/%{ui_name}-%{commitId_catalog_ui}
cp %{_builddir}/automation-catalog-ui-productization/pinakes/* %{_builddir}/%{ui_name}-%{commitId_catalog_ui}/src/assets/images/
npm install --build-from-source --legacy-peer-deps
APPLICATION_NAME='Automation Services Catalog' npm run build:standalone

%install
install -m 0755 -vd                     %{buildroot}%{_unitdir}

# add system unit files
install -m 644 %{SOURCE7}               %{buildroot}%{_unitdir}
install -m 644 %{SOURCE2}               %{buildroot}%{_unitdir}
install -m 644 %{SOURCE3}               %{buildroot}%{_unitdir}
install -m 644 %{SOURCE4}               %{buildroot}%{_unitdir}
install -m 644 %{SOURCE6}               %{buildroot}%{_unitdir}

# install ui
mkdir -p %{buildroot}%{python3_sitelib}/%{pypi_name}/ui/catalog/
cp -a %{_builddir}/%{ui_name}-%{commitId_catalog_ui}/dist/* %{buildroot}%{python3_sitelib}/%{pypi_name}/ui/catalog/

# add manage script to reasonable location
mkdir -p %{buildroot}%{_sharedstatedir}/ansible-automation-platform/services-catalog
cp -a manage.py %{buildroot}%{_sharedstatedir}/ansible-automation-platform/services-catalog/

# add configuration directory
mkdir -p %{buildroot}%{_sysconfdir}/ansible-automation-platform/services-catalog

# add directory for sockets
mkdir -p %{buildroot}%{_rundir}/ansible-automation-platform

# install pinakes
export PBR_VERSION=%{version}
%{py3_install}

%pre
getent group pinakes >/dev/null || groupadd -r pinakes
getent passwd pinakes >/dev/null || \
    useradd -r -g pinakes -G nginx,redis -d %{_sharedstatedir}/ansible-automation-platform/services-catalog -s %{_bindir}/bash pinakes

%files
%defattr(-,root,root)
%{python3_sitelib}/%{pypi_name}
%{python3_sitelib}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%{_unitdir}/automation-services-catalog.target
%{_unitdir}/automation-services-catalog.socket
%{_unitdir}/automation-services-catalog.service
%{_unitdir}/automation-services-catalog-worker.service
%{_unitdir}/automation-services-catalog-scheduler.service

%attr(0755,pinakes,pinakes) %{_sharedstatedir}/ansible-automation-platform/services-catalog
%attr(0750,pinakes,root) %{_sysconfdir}/ansible-automation-platform/services-catalog
%attr(2775,nginx,nginx) %{_rundir}/ansible-automation-platform

%changelog
* Wed Sep 21 2022 Dimitri Savineau <dsavinea@redhat.com> - 1.0.9-3
- Add missing cryptography runtime dependency

* Thu Sep 01 2022 James Marshall <jamarsha@redhat.com> - 1.0.9-2
- Fixed missing non-code files for build

* Mon Aug 01 2022 James Marshall <jamarsha@redhat.com> - 1.0.9-1
- Bump version to 1.0.9
- Bump automation-catalog-ui version to 1.0.9

* Thu Jun 09 2022 James Marshall <jamarsha@redhat.com> - 1.0.7-1
- Bump version to 1.0.7-1
- Bump automation-catalog-ui version to 1.0.8
- Add target unit for catalog components
- Fix pinakes group membership to nginx and redis
- Add python distro and rq module to dependencies for pinakes analytics

* Thu Jun 02 2022 James Marshall <jamarsha@redhat.com> - 1.0.6-2
- Remove approval-ui source, add localization fixes, and change branding images

* Thu May 12 2022 Yanis Guenane <yguenane@redhat.com> - 1.0.6-1
- Initial package
